
#ifndef _PATTERN2_H_

#define _PATTERN2_H_

#include <stdint.h>

#define PATTERN2_HEADER "Pattern2 - 0.2"
#define AS3D_END "End"
#define AS3D_TITLE "Title:"
#define AS3D_SCENE "Scene:"
#define AS3D_VALUE "Value:"
#define AS3D_CHILD "Child:"
#define AS3D_SIBLING "Sibling:"

#ifndef BUFFER_SIZE
  #define BUFFER_SIZE 512
#endif // BUFFER_SIZE

int getNextLine(FILE *stream, char *sLine);
int getNextWord(char *sOut, const char *sList, int *iEnd);
int getNextInt(char *sList, int *iEnd);
float getNextFloat(char *sList, int *iEnd);
char getNextChar(char *sList, int *iEnd);
int getNextBool(char *sList, int *iEnd, const char *sCompare);

int writeError(char *sIncorrect, const char *sCorrect);

struct pattern;

typedef struct pattern {
	int     m_bVerbose;			// Print Debug  Info Flag On/Off.
	int     m_bDebug;			// Print Memory Info Flag On/Off.
	int     m_bErrors;			// Print Errors Info Flag On/Off.
	char   *m_sAppHdr;
	char   *m_sTitle;
	int     m_iScene;           // Scene Number
	char   *m_sScene;           // Scene Name
	uint8_t *value;             // The bytes.
	int     value_len;             // The bytes.
	uint8_t *output;             // The bytes.
	int     output_len;             // The bytes.

	struct pattern *firstChild;
	struct pattern *nextSibling;
} pattern;

int pattern_AS3DFile(pattern *p, int iVerbosity, char *sHeader);
int pattern_deconst_AS3DFile(pattern *p);
int pattern_destroy(pattern *p);
int pattern_addChild(pattern *p, pattern *child);
int pattern_addSibling(pattern *p, pattern *sibling);
int pattern_load(pattern *p, const char *sFilename);
int pattern_saveASD(pattern *p, const char *filename);   // Save data to data file
int pattern_setDir(pattern *p, char *aDir);

int pattern_readData(pattern *p, FILE *asd_in);
int pattern_writeData(pattern *p, FILE *asd_out);

int pattern_compare(pattern *p, pattern *list, pattern **match);
pattern *pattern_find(pattern *p, uint8_t *value, int len);
int pattern_input(pattern *tree, uint8_t *tree_input, int len, uint8_t *out_value, int out_len);

#define min(a, b) ((a) < (b) ? (a) : (b))

#endif // _PATTERN2_H_

